// PPListDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PPList.h"
#include "PPListDlg.h"
#include "LinkText.h"
#include <process.h>
#include <direct.h>
#include <io.h>

const char*	CPPListDlg::s_settingFileName = "PPList.txt";

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CLinkText	m_link;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINK_TEXT, m_link);
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString	s;
	s.Format("PPList Version %.2f",CPPListApp::s_appVersion * 0.01);
	GetDlgItem(IDC_VERSION)->SetWindowText(s);
	return TRUE;
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPListDlg _CAO

CPPListDlg::CPPListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPPListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPListDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPPListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPListDlg)
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPPListDlg, CDialog)
	//{{AFX_MSG_MAP(CPPListDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_OPT, OnOpt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPListDlg bZ[W nh

BOOL CPPListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B
	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	m_lay.SetType(GetDlgItem(IDOK),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDCANCEL),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_DEL),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_CLEAR),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_OPT),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(&m_list,CLayoutManager::FreeSize,CLayoutManager::FreeSize);
	m_lay.Reset();
	int		x,y, ver = 0, k = 0;
	char	buf[512],*p;
	GetModuleFileName(0,buf,sizeof(buf));
	p = strrchr(buf,'\\');
	if (p) *p = 0;
	chdir(buf);
	FILE* f = fopen(s_settingFileName,"r");
	if (f) {
		fgets(buf,sizeof(buf),f);
		sscanf(buf,"%d",&ver);
		fgets(buf,sizeof(buf),f);
		if (sscanf(buf,"%d %d",&x,&y) == 2) {
			SetWindowPos(0,0,0,x,y,SWP_NOMOVE);
		}
		fgets(buf,sizeof(buf),f);
		sscanf(buf,"%d",&k);
		while (fgets(buf,sizeof(buf),f)) {
			p = buf+strlen(buf)-1;
			if (*p == '\n') *p = 0;
			m_list.AddString(buf);
		}
		fclose(f);
		m_list.SetCurSel(k);
	}
	if (!f || GetKeyState(VK_SHIFT) < 0) {
		if (MB("t@C荞݂܂H",MB_YESNO) == IDYES) {
			_finddata_t	fd;
			long		h;
			if ((h = _findfirst("*.pp*",&fd)) != -1L) {
				do {
					m_list.AddString(fd.name);
				} while (_findnext(h,&fd) == 0);
				_findclose(h);
			}
		}
	}
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CPPListDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CPPListDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CPPListDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPPListDlg::OnDropFiles(HDROP hDropInfo) 
{
	int		i,j,k,n;
	char	buf[MAX_PATH+1],*p;
	k = m_list.GetCurSel();
	n = ::DragQueryFile(hDropInfo,0xffffffff,buf,sizeof(buf)-1);
	for (i=0;i<n;i++) {
		::DragQueryFile(hDropInfo,i,buf,sizeof(buf)-1);
		p = strrchr(buf,'.');
		if (!p || (stricmp(p,".ppt") && stricmp(p,".pps")))
			continue;
		if (GetKeyState(VK_CONTROL) >= 0) {
			j = m_list.FindStringExact(-1,buf);
			if (j != LB_ERR) continue;
		}
		if (GetKeyState(VK_SHIFT) < 0) {
			p = strrchr(buf,'\\');
			if (p) strcpy(buf,p+1);
		}
		m_list.AddString(buf);
	}
	::DragFinish(hDropInfo);
	if (k == LB_ERR) k = 0;
	m_list.SetCurSel(k);
//	CDialog::OnDropFiles(hDropInfo);
}

void CPPListDlg::OnClear() 
{
	m_list.ResetContent();
}

void CPPListDlg::OnDel() 
{
	int	n, i = m_list.GetCurSel();
	if (i == LB_ERR) {
		MB("Select it");
		return;
	}
	m_list.DeleteString(i);
	n = m_list.GetCount();
	m_list.SetCurSel(i < n ? i : i-1);
}

void CPPListDlg::OnOK() 
{
	int		n, i = m_list.GetCurSel();
	CString	s;
	if (i == LB_ERR) {
		MB("Select it");
		return;
	}
	char	buf[512];
	DWORD	d = 512;
	HKEY	h;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\CLASSES\\CLSID\\"
		"{64818D10-4F9B-11CF-86EA-00AA00B929E8}\\LocalServer32",0,KEY_READ,&h) != ERROR_SUCCESS) {
		MB("Can't find PowerPnt.exe");
		return;
	}
	CWinApp* p = AfxGetApp();
	*buf = 0;
	RegQueryValueEx(h,"",0,0,(LPBYTE)buf,&d);
	RegCloseKey(h);
	n = m_list.GetCount();
	for (;i<n;++i) {
		spawnl(_P_NOWAIT,"PPTimer.exe"," ",0);
		m_list.GetText(i,s);
		spawnl(_P_WAIT,buf," ","/s","\""+s+"\"",0);
		if (i < n-1 && MB("Show next?",MB_YESNO) != IDYES)
			break;
	}
	spawnl(_P_WAIT,"PPTimer.exe"," ","/x",0);
	m_list.SetCurSel(i+1);
//	CDialog::OnOK();
}

void CPPListDlg::OnCancel() 
{
	CRect		r;
	CString		s;
	int			i, n = m_list.GetCount();
	FILE* f = fopen(s_settingFileName,"w");
	if (f) {
		GetWindowRect(&r);
		i = m_list.GetCurSel();
		fprintf(f,"%d\n%d %d\n%d\n",CPPListApp::s_appVersion,
			r.Width(),r.Height(), i == LB_ERR ? 0 : i);
		for (i=0;i<n;++i) {
			m_list.GetText(i,s);
			fprintf(f,"%s\n",(const char*)s);
		}
		fclose(f);
	}
	CDialog::OnCancel();
}

void CPPListDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if (nType == 0 || nType == 2) m_lay.Layout();
}

void CPPListDlg::OnOpt() 
{
	spawnl(_P_WAIT,"PPTimer.exe"," ","/o",0);
}
