// PPTimerDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PPTimer.h"
#include "PPTimerDlg.h"
#include <mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPTimerDlg _CAO

CPPTimerDlg::CPPTimerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPPTimerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPTimerDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bDrag = false;
	m_bStop = false;
	m_opt.m_it = m_opt.m_data.begin();
	m_opt.Load();
}

void CPPTimerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPTimerDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPPTimerDlg, CDialog)
	//{{AFX_MSG_MAP(CPPTimerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_POP_EXIT, OnPopExit)
	ON_WM_TIMER()
	ON_COMMAND(ID_POP_OPT, OnPopOpt)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPTimerDlg bZ[W nh

bool CPPTimerDlg::CheckMove(UINT& nFlags,CPoint& point)
{
	MSG msg;
	while (::GetMessage(&msg,0,0,0) >= 0) {
		if (msg.message == WM_MOUSEMOVE || msg.message == WM_LBUTTONUP) {
			nFlags = msg.wParam;
			point = CPoint((DWORD)msg.lParam);
			return msg.message == WM_MOUSEMOVE;
		}
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
	return false;
}

void CPPTimerDlg::OnMouseClick(UINT nFlags, CPoint point0)
{
	CRect	r;
	CPoint	pt;
	while (CheckMove(nFlags,pt)) {
		m_bDrag = true;
		GetWindowRect(&r);
		SetWindowPos(0,r.left + pt.x - 12,r.top + pt.y - 9,0,0,SWP_NOSIZE | SWP_NOZORDER);
	}
}

void CPPTimerDlg::StartTimer(bool bReset)
{
	if (bReset) {
		m_opt.m_elapse = 0;
		m_opt.m_it = m_opt.m_data.begin();
	}
	KillTimer(1000);
	SetTimer(1000,1000,0);
}

CString CPPTimerDlg::GetString()
{
	int		t;
	CString	s = m_opt.m_bNotShowTime ? " " : Time2Str(m_opt.m_elapse);
	if (m_opt.m_it == m_opt.m_data.end()) {
		s += " " + m_opt.m_last;
	} else {
		while (m_opt.m_it != m_opt.m_data.end()) {
			t = m_opt.m_it->first;
			if (m_opt.m_elapse >= t && m_opt.m_elapse < t + m_opt.m_delay) {
				s += " " + m_opt.m_it->second.m_msg;
			} else if (t < m_opt.m_elapse) {
				++m_opt.m_it;
				continue;
			}
			break;
		}
	}
	return s;
}

BOOL CPPTimerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	SetWindowText("PPTimer");
	SetWindowPos(0,m_opt.m_pos.x,m_opt.m_pos.y,0,0,SWP_NOSIZE | SWP_NOZORDER);
	StartTimer(true);
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CPPTimerDlg::OnPaint() 
{
	if (GetCapture()) return;
	CPaintDC dc(this);
	CDC* pDC = &dc;
	if (IsIconic()) {
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
		return;
	}
//	CDialog::OnPaint();
	pDC->SetTextColor(m_opt.m_col1.m_color);
	pDC->SetBkColor(m_opt.m_col2.m_color);
	CString	s = GetString();
	CRect	r(0,0,0,0);
	pDC->DrawText(s,&r,DT_CALCRECT);
	SetWindowPos(0,0,0,r.right,r.bottom,SWP_NOMOVE | SWP_NOZORDER);
	pDC->TextOut(0,0,s);
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CPPTimerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPPTimerDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu menu;
	VERIFY(menu.LoadMenu(IDR_POPUP_MENU));
	CMenu* pPopup = menu.GetSubMenu(0); 
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
}

void CPPTimerDlg::OnPopExit() 
{
//	m_opt.Save();
	CDialog::OnOK();
}

void CPPTimerDlg::OnTimer(UINT nIDEvent) 
{
	if (m_bStop) {
		KillTimer(1000);
		return;
	}
	++m_opt.m_elapse;
	Invalidate();
	if (m_opt.m_it != m_opt.m_data.end()) {
		if (m_opt.m_elapse == m_opt.m_it->first) {
			CString& w = m_opt.m_it->second.m_wav;
			if (!w.IsEmpty())
				PlaySound(w,0,SND_ASYNC);
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CPPTimerDlg::OnPopOpt() 
{
	KillTimer(1000);
	CDlgOption	dlg;
	dlg.Set(m_opt);
	int res = dlg.DoModal();
	StartTimer(false);
	if (res == IDOK) {
		m_opt.Set(dlg);
		m_opt.Save();
		Invalidate();
	}
}

void CPPTimerDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (!GetCapture()) {
		m_bDrag = false;
		SetCapture();
		OnMouseClick(nFlags,point);
		ReleaseCapture();
		if (m_bDrag) {
			CRect	r;
			GetWindowRect(&r);
			m_opt.m_pos = r.TopLeft();
			m_opt.Save();
		} else {
			m_bStop = !m_bStop;
			if (!m_bStop) StartTimer(false);
		}
	}
}

void CPPTimerDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	OnPopExit();
}
